package pl.webnet.JaTrac;

//import com.microstar.xml.XmlHandler;
import com.microstar.xml.XmlParser;
import com.microstar.xml.HandlerBase;
import java.net.*;
import java.util.*;

public class Loader extends HandlerBase
{
	Stack objectStack;
	Class thisclass = null;
	Object current = null;
	String currentParam;
	String currentValue;
	Scene scene;
	

	public Loader()
	{
	}

	public Scene load(String name)
	{
		XmlParser parser = new XmlParser();
		parser.setHandler(this);

		objectStack = new Stack();

		try {
			parser.parse("file://" + name, null, (String)null);
		} catch (Exception e) { e.printStackTrace(); }

		return scene;
	}

	public void startElement(String el)
	{
		System.out.println("startElement: " + el);

		try {
			objectStack.push(current);
			thisclass = Class.forName("pl.webnet.JaTrac." + el);

			current = thisclass.newInstance();

			if(current instanceof Scene)
				scene = (Scene)current;
			
		} catch (Exception e)
		{
			currentParam = el;

			System.out.println("class " + el + " not found, treating as an attribute");
		}

	}

	public void ignorableWhitespace(char ch[], int start, int length)
	{
		System.out.println("ignorable: " + new String (ch, start, length));
	}

	public void charData(char ch[], int start, int length)
	{
//		System.out.println("Data: " + new String (ch, start, length));

		currentValue = new String (ch, start, length);
	}

	public void endElement(String e)
	{
		System.out.println("endElement: " + e);

		Object prev = current;

		current = objectStack.pop();

		if(current != null)
			if(currentParam != null)
			{
				ParamHelper.set(current, ((XmlSettable)current).getParamArray(), currentParam, currentValue);
//				((XmlSettable)current).setParam(currentParam, currentValue);
			}
			else
				((XmlSettable)current).addObject(prev);

		currentParam = null;
	}

	public void attribute(String a, String v, boolean isSpecified)
	{
		System.out.println("attrinute: " + a + "," + v + "," + isSpecified);
	}
}

