package pl.webnet.JaTrac;

import java.awt.*;

class Pixel
{
	static public final int RANGE_8BIT = 255;

	double r, g, b, a;
	Ray ray;
	
	public Pixel(double r, double g, double b)
	{
		this.r = r;
		this.g = g;
		this.b = b;
	}

	public Pixel(Spectrum s)
	{
		double[] components;
		components = s.getRGB(null);
		
		this.r = components[0];
		this.g = components[1];
		this.b = components[2];
	}

	public int getRGB()
	{
		return ((int)(r * RANGE_8BIT) << 16) + ((int)(g * RANGE_8BIT) << 8) + ((int)(b * RANGE_8BIT));
	}
}
