package pl.webnet.JaTrac;

import java.awt.*;

class PointLight extends Light implements XmlSettable
{
	public PointLight()
	{
	}

	public PointLight(Point origin, Spectrum spectrum)
	{
		this.origin = new Point(origin);
		this.spectrum = spectrum;
	}

	public String[] getParamArray()
	{
		String params[] = {
			"origin", "origin", "",
			"spectrum", "", "setSpectrum"
		};

		return params;
	}

	public void addObject(Object o) {}


	public Double shadow(RayTree rt, Point hitPoint, Vec lightVec, double len)
	{
		Ray lightRay = new Ray(hitPoint, lightVec);

		if(rt.intersect(lightRay) != 0)
		{
			if(((Intersection)lightRay.intersections.first()).t < len - Ray.EPSILON)
				if(((Intersection)lightRay.intersections.first()).t >= Ray.EPSILON)
				return new Double(0.);
		}
			
		return new Double(1.);
	}
}
