package pl.webnet.JaTrac;

import java.util.*;
import java.awt.*;

class Ray extends Vec
{
	static public final double EPSILON = 1e-9;
	static int count = 0;

	Point origin;
	TreeSet intersections;
	Ray reflectedRay = null;
	Ray[] shadow = null;
	Ray transmittedRay = null;
	Spectrum spectrum;

	public Ray(Point origin, Vec direction)
	{
		this.origin = new Point(origin);
		intersections = new TreeSet();
		copy(direction);
		unit();
		count++;
	}

	public Point rayPoint(double t)
	{
		return new Point(x * t + origin.x, y * t + origin.y, z * t + origin.z);
	}

}
