package pl.webnet.JaTrac;

import java.awt.image.*;

class Screen implements XmlSettable
{
	Pixel[][] pixels;
	protected int width, height;
	int AAFactor;

	public Screen()
	{
	}

	public Screen(int width, int height)
	{
		this.width = width;
		this.height = height;
	}

	public void init()
	{
		pixels = new Pixel[height][width];

		for(int y = 0; y < height; y++)
			for(int x = 0; x < width; x++)
			{
				pixels[y][x] = new Pixel(0., 0., 0.);
			}
	}

	public String[] getParamArray()
	{
		String params[] = {
			"width", "width", "",
			"height", "height", "",
			"antialias", "AAFactor", ""
		};

		return params;
	}

	public void addObject(Object o) {}

	public int getWidth()
	{
		return width;
	}
	
	public int getHeight()
	{
		return height;
	}
	
	public BufferedImage toImage()
	{
		BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);

		for(int y = 0; y < height; y++)
			for(int x = 0; x < width; x++)
			{
				bi.setRGB(x, y, pixels[y][x].getRGB());
			}

		return bi;
	}
}
